Index: kernel/arch/amd64/include/arch/interrupt.h
===================================================================
--- kernel/arch/amd64/include/arch/interrupt.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/include/arch/interrupt.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,7 +36,7 @@
 #define KERN_amd64_INTERRUPT_H_
 
-#include <typedefs.h>
 #include <arch/istate.h>
 #include <arch/pm.h>
+#include <stdint.h>
 
 #define IVT_ITEMS  IDT_ITEMS
Index: kernel/arch/amd64/include/arch/mm/frame.h
===================================================================
--- kernel/arch/amd64/include/arch/mm/frame.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/include/arch/mm/frame.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,6 +43,4 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
-
 extern void frame_low_arch_init(void);
 extern void frame_high_arch_init(void);
Index: kernel/arch/amd64/include/arch/mm/km.h
===================================================================
--- kernel/arch/amd64/include/arch/mm/km.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/include/arch/mm/km.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #define KERN_amd64_KM_H_
 
+#include <stdbool.h>
 #include <typedefs.h>
 
Index: kernel/arch/amd64/include/arch/proc/task.h
===================================================================
--- kernel/arch/amd64/include/arch/proc/task.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/include/arch/proc/task.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,6 +36,6 @@
 #define KERN_amd64_TASK_H_
 
-#include <typedefs.h>
 #include <adt/bitmap.h>
+#include <stddef.h>
 
 typedef struct {
Index: kernel/arch/amd64/include/arch/proc/thread.h
===================================================================
--- kernel/arch/amd64/include/arch/proc/thread.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/include/arch/proc/thread.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define KERN_amd64_THREAD_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 typedef struct {
Index: kernel/arch/amd64/include/arch/types.h
===================================================================
--- kernel/arch/amd64/include/arch/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/include/arch/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,6 @@
 #define KERN_amd64_TYPES_H_
 
+#include <arch/common.h>
+
 typedef uint64_t size_t;
 typedef int64_t ssize_t;
@@ -51,7 +53,4 @@
 } fncptr_t;
 
-#define INTN_C(c)   INT64_C(c)
-#define UINTN_C(c)  UINT64_C(c)
-
 #define PRIdn  PRId64  /**< Format for native_t. */
 #define PRIun  PRIu64  /**< Format for sysarg_t. */
Index: kernel/arch/amd64/include/arch/vreg.h
===================================================================
--- kernel/arch/amd64/include/arch/vreg.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/include/arch/vreg.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,5 +40,5 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
+#include <stdint.h>
 
 extern uint64_t *vreg_ptr;
Index: kernel/arch/amd64/src/amd64.c
===================================================================
--- kernel/arch/amd64/src/amd64.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/src/amd64.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,7 +35,7 @@
 #include <arch.h>
 #include <arch/arch.h>
-#include <typedefs.h>
+#include <stdint.h>
 #include <errno.h>
-#include <memstr.h>
+#include <mem.h>
 #include <interrupt.h>
 #include <console/console.h>
Index: kernel/arch/amd64/src/boot/multiboot2.S
===================================================================
--- kernel/arch/amd64/src/boot/multiboot2.S	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/src/boot/multiboot2.S	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -54,4 +54,5 @@
 		.word MULTIBOOT2_FLAGS_REQUIRED
 		.long tag_info_req_end - tag_info_req_start
+		.long MULTIBOOT2_TAG_CMDLINE
 		.long MULTIBOOT2_TAG_MODULE
 		.long MULTIBOOT2_TAG_MEMMAP
Index: kernel/arch/amd64/src/cpu/cpu.c
===================================================================
--- kernel/arch/amd64/src/cpu/cpu.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/src/cpu/cpu.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,5 +39,4 @@
 
 #include <arch.h>
-#include <typedefs.h>
 #include <print.h>
 #include <fpu_context.h>
Index: kernel/arch/amd64/src/ddi/ddi.c
===================================================================
--- kernel/arch/amd64/src/ddi/ddi.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/src/ddi/ddi.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,6 +35,6 @@
 #include <ddi/ddi.h>
 #include <arch/ddi/ddi.h>
+#include <assert.h>
 #include <proc/task.h>
-#include <typedefs.h>
 #include <adt/bitmap.h>
 #include <mm/slab.h>
@@ -45,4 +45,5 @@
 #include <arch.h>
 #include <align.h>
+#include <stdbool.h>
 
 /** Install I/O Permission bitmap.
@@ -63,5 +64,5 @@
 	
 	if (elements > 0) {
-		ASSERT(TASK->arch.iomap.bits);
+		assert(TASK->arch.iomap.bits);
 		
 		bitmap_t iomap;
Index: kernel/arch/amd64/src/debug/stacktrace.c
===================================================================
--- kernel/arch/amd64/src/debug/stacktrace.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/src/debug/stacktrace.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,5 @@
 
 #include <stacktrace.h>
+#include <stdbool.h>
 #include <syscall/copy.h>
 #include <typedefs.h>
Index: kernel/arch/amd64/src/interrupt.c
===================================================================
--- kernel/arch/amd64/src/interrupt.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/src/interrupt.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,7 +34,7 @@
 
 #include <arch/interrupt.h>
+#include <assert.h>
 #include <print.h>
 #include <log.h>
-#include <debug.h>
 #include <panic.h>
 #include <arch/drivers/i8259.h>
@@ -175,10 +175,10 @@
 static void irq_interrupt(unsigned int n, istate_t *istate)
 {
-	ASSERT(n >= IVT_IRQBASE);
+	assert(n >= IVT_IRQBASE);
 	
 	unsigned int inum = n - IVT_IRQBASE;
 	bool ack = false;
-	ASSERT(inum < IRQ_COUNT);
-	ASSERT((inum != IRQ_PIC_SPUR) && (inum != IRQ_PIC1));
+	assert(inum < IRQ_COUNT);
+	assert((inum != IRQ_PIC_SPUR) && (inum != IRQ_PIC1));
 	
 	irq_t *irq = irq_dispatch_and_lock(inum);
Index: kernel/arch/amd64/src/kseg.c
===================================================================
--- kernel/arch/amd64/src/kseg.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/src/kseg.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,4 @@
 
 #include <arch/kseg.h>
-#include <typedefs.h>
 #include <arch/asm.h>
 #include <panic.h>
Index: kernel/arch/amd64/src/mm/km.c
===================================================================
--- kernel/arch/amd64/src/mm/km.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/src/mm/km.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,6 +34,6 @@
 #include <mm/km.h>
 #include <config.h>
-#include <typedefs.h>
 #include <macros.h>
+#include <stdbool.h>
 
 void km_identity_arch_init(void)
Index: kernel/arch/amd64/src/mm/page.c
===================================================================
--- kernel/arch/amd64/src/mm/page.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/src/mm/page.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,5 +41,4 @@
 #include <arch/asm.h>
 #include <config.h>
-#include <memstr.h>
 #include <interrupt.h>
 #include <print.h>
Index: kernel/arch/amd64/src/pm.c
===================================================================
--- kernel/arch/amd64/src/pm.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/src/pm.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,5 +39,5 @@
 #include <mm/as.h>
 #include <mm/frame.h>
-#include <memstr.h>
+#include <mem.h>
 #include <mm/slab.h>
 
Index: kernel/arch/amd64/src/proc/task.c
===================================================================
--- kernel/arch/amd64/src/proc/task.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/src/proc/task.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,5 @@
 
 #include <proc/task.h>
-#include <typedefs.h>
+#include <stddef.h>
 #include <adt/bitmap.h>
 #include <mm/slab.h>
Index: kernel/arch/amd64/src/userspace.c
===================================================================
--- kernel/arch/amd64/src/userspace.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/amd64/src/userspace.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #include <arch/cpu.h>
 #include <arch/pm.h>
-#include <typedefs.h>
+#include <stdint.h>
 #include <arch.h>
 #include <abi/proc/uarg.h>
Index: kernel/arch/arm32/Makefile.inc
===================================================================
--- kernel/arch/arm32/Makefile.inc	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/Makefile.inc	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,5 +33,5 @@
 ATSIGN = %
 
-GCC_CFLAGS += -fno-omit-frame-pointer -mapcs-frame -march=$(subst _,-,$(PROCESSOR_ARCH)) -mno-unaligned-access -mfpu=vfpv3
+COMMON_CFLAGS += -fno-omit-frame-pointer -mapcs-frame -march=$(subst _,-,$(PROCESSOR_ARCH)) -mno-unaligned-access -mfpu=vfpv3
 
 ifeq ($(CONFIG_FPU),y)
Index: kernel/arch/arm32/include/arch/arch.h
===================================================================
--- kernel/arch/arm32/include/arch/arch.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/include/arch/arch.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -42,5 +42,5 @@
 #define BOOTINFO_TASK_NAME_BUFLEN 32
 
-#include <typedefs.h>
+#include <stddef.h>
 
 typedef struct {
Index: kernel/arch/arm32/include/arch/cp15.h
===================================================================
--- kernel/arch/arm32/include/arch/cp15.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/include/arch/cp15.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,9 +37,5 @@
 #define KERN_arm32_CP15_H_
 
-#if defined(KERNEL) || defined(BOOT)
-#include <typedefs.h>
-#else
 #include <stdint.h>
-#endif
 
 /** See ARM Architecture reference manual ch. B3.17.1 page B3-1456
Index: kernel/arch/arm32/include/arch/cpu.h
===================================================================
--- kernel/arch/arm32/include/arch/cpu.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/include/arch/cpu.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,6 +37,6 @@
 #define KERN_arm32_CPU_H_
 
-#include <typedefs.h>
 #include <arch/asm.h>
+#include <stdint.h>
 
 enum {
Index: kernel/arch/arm32/include/arch/fpu_context.h
===================================================================
--- kernel/arch/arm32/include/arch/fpu_context.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/include/arch/fpu_context.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,6 @@
 #define KERN_arm32_FPU_CONTEXT_H_
 
-#include <typedefs.h>
+#include <stdbool.h>
+#include <stdint.h>
 
 #define FPU_CONTEXT_ALIGN    8
Index: kernel/arch/arm32/include/arch/interrupt.h
===================================================================
--- kernel/arch/arm32/include/arch/interrupt.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/include/arch/interrupt.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,5 @@
 #define KERN_arm32_INTERRUPT_H_
 
-#include <typedefs.h>
+#include <stdbool.h>
 #include <arch/exception.h>
 
Index: kernel/arch/arm32/include/arch/mm/asid.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/asid.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/include/arch/mm/asid.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,5 +39,5 @@
 #define KERN_arm32_ASID_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 #define ASID_MAX_ARCH		3	/* minimal required number */
Index: kernel/arch/arm32/include/arch/mm/frame.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/frame.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/include/arch/mm/frame.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -44,6 +44,4 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
-
 #define BOOT_PAGE_TABLE_SIZE     0x4000
 
Index: kernel/arch/arm32/include/arch/mm/km.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/km.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/include/arch/mm/km.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #define KERN_arm32_KM_H_
 
+#include <stdbool.h>
 #include <typedefs.h>
 
Index: kernel/arch/arm32/include/arch/mm/page_fault.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/page_fault.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/include/arch/mm/page_fault.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,5 @@
 #define KERN_arm32_PAGE_FAULT_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 
Index: kernel/arch/arm32/include/arch/types.h
===================================================================
--- kernel/arch/arm32/include/arch/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/include/arch/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,6 @@
 #define KERN_arm32_TYPES_H_
 
+#include <arch/common.h>
+
 #ifndef DOXYGEN
 	#define ATTRIBUTE_PACKED __attribute__((packed))
@@ -58,7 +60,4 @@
 } fncptr_t;
 
-#define INTN_C(c)   INT32_C(c)
-#define UINTN_C(c)  UINT32_C(c)
-
 #define PRIdn  PRId32  /**< Format for native_t. */
 #define PRIun  PRIu32  /**< Format for sysarg_t. */
Index: kernel/arch/arm32/src/interrupt.c
===================================================================
--- kernel/arch/arm32/src/interrupt.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/src/interrupt.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,4 @@
 #include <arch/machine_func.h>
 #include <ddi/irq.h>
-#include <ddi/device.h>
 #include <interrupt.h>
 
Index: kernel/arch/arm32/src/mach/beagleboardxm/beagleboardxm.c
===================================================================
--- kernel/arch/arm32/src/mach/beagleboardxm/beagleboardxm.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/src/mach/beagleboardxm/beagleboardxm.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,4 +35,5 @@
 #include <arch/exception.h>
 #include <arch/mach/beagleboardxm/beagleboardxm.h>
+#include <assert.h>
 #include <genarch/drivers/amdm37x/uart.h>
 #include <genarch/drivers/amdm37x/irc.h>
@@ -43,5 +44,4 @@
 #include <mm/km.h>
 #include <ddi/ddi.h>
-#include <ddi/device.h>
 
 static void bbxm_init(void);
@@ -102,5 +102,5 @@
 	    (void *) km_map(AMDM37x_IRC_BASE_ADDRESS, AMDM37x_IRC_SIZE,
 	    PAGE_NOT_CACHEABLE);
-	ASSERT(beagleboard.irc_addr);
+	assert(beagleboard.irc_addr);
 	omap_irc_init(beagleboard.irc_addr);
 
@@ -116,5 +116,4 @@
 	static irq_t timer_irq;
 	irq_initialize(&timer_irq);
-	timer_irq.devno = device_assign_devno();
 	timer_irq.inr = AMDM37x_GPT1_IRQ;
 	timer_irq.claim = bb_timer_irq_claim;
Index: kernel/arch/arm32/src/mach/beaglebone/beaglebone.c
===================================================================
--- kernel/arch/arm32/src/mach/beaglebone/beaglebone.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/src/mach/beaglebone/beaglebone.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #include <arch/exception.h>
 #include <arch/mach/beaglebone/beaglebone.h>
+#include <assert.h>
 #include <genarch/drivers/am335x/irc.h>
 #include <genarch/drivers/am335x/uart.h>
@@ -45,5 +46,4 @@
 #include <interrupt.h>
 #include <ddi/ddi.h>
-#include <ddi/device.h>
 #include <mm/km.h>
 
@@ -98,8 +98,8 @@
 	    AM335x_CTRL_MODULE_SIZE, PAGE_NOT_CACHEABLE);
 
-	ASSERT(bbone.irc_addr != NULL);
-	ASSERT(bbone.cm_per_addr != NULL);
-	ASSERT(bbone.cm_dpll_addr != NULL);
-	ASSERT(bbone.ctrl_module != NULL);
+	assert(bbone.irc_addr != NULL);
+	assert(bbone.cm_per_addr != NULL);
+	assert(bbone.cm_dpll_addr != NULL);
+	assert(bbone.ctrl_module != NULL);
 
 	/* Initialize the interrupt controller */
@@ -128,5 +128,4 @@
 	static irq_t timer_irq;
 	irq_initialize(&timer_irq);
-	timer_irq.devno = device_assign_devno();
 	timer_irq.inr = AM335x_DMTIMER2_IRQ;
 	timer_irq.claim = bbone_timer_irq_claim;
Index: kernel/arch/arm32/src/mach/gta02/gta02.c
===================================================================
--- kernel/arch/arm32/src/mach/gta02/gta02.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/src/mach/gta02/gta02.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,5 +48,4 @@
 #include <interrupt.h>
 #include <ddi/ddi.h>
-#include <ddi/device.h>
 #include <log.h>
 
@@ -241,5 +240,4 @@
 {
 	irq_initialize(&gta02_timer_irq);
-	gta02_timer_irq.devno = device_assign_devno();
 	gta02_timer_irq.inr = GTA02_TIMER_IRQ;
 	gta02_timer_irq.claim = gta02_timer_irq_claim;
Index: kernel/arch/arm32/src/mach/integratorcp/integratorcp.c
===================================================================
--- kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,5 +43,4 @@
 #include <console/console.h>
 #include <sysinfo/sysinfo.h>
-#include <ddi/device.h>
 #include <mm/page.h>
 #include <mm/frame.h>
@@ -207,5 +206,4 @@
 {
 	irq_initialize(&icp.timer_irq);
-	icp.timer_irq.devno = device_assign_devno();
 	icp.timer_irq.inr = ICP_TIMER_IRQ;
 	icp.timer_irq.claim = icp_timer_claim;
Index: kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c
===================================================================
--- kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #include <arch/exception.h>
 #include <arch/mach/raspberrypi/raspberrypi.h>
+#include <assert.h>
 #include <genarch/drivers/pl011/pl011.h>
 #include <genarch/drivers/bcm2835/irc.h>
@@ -49,5 +50,4 @@
 #include <interrupt.h>
 #include <ddi/ddi.h>
-#include <ddi/device.h>
 
 #define RPI_DEFAULT_MEMORY_START	0
@@ -103,5 +103,5 @@
 	raspi.irc = (void *) km_map(BCM2835_IRC_ADDR, sizeof(bcm2835_irc_t),
 				    PAGE_NOT_CACHEABLE);
-	ASSERT(raspi.irc);
+	assert(raspi.irc);
 	bcm2835_irc_init(raspi.irc);
 
@@ -117,5 +117,4 @@
 	static irq_t timer_irq;
 	irq_initialize(&timer_irq);
-	timer_irq.devno = device_assign_devno();
 	timer_irq.inr = BCM2835_TIMER1_IRQ;
 	timer_irq.claim = raspberrypi_timer_irq_claim;
Index: kernel/arch/arm32/src/mm/km.c
===================================================================
--- kernel/arch/arm32/src/mm/km.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/src/mm/km.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,5 @@
 #include <mm/km.h>
 #include <config.h>
+#include <stdbool.h>
 #include <typedefs.h>
 #include <macros.h>
Index: kernel/arch/arm32/src/ras.c
===================================================================
--- kernel/arch/arm32/src/ras.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/arm32/src/ras.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -44,5 +44,5 @@
 #include <arch/exception.h>
 #include <arch.h>
-#include <memstr.h>
+#include <mem.h>
 #include <typedefs.h>
 
Index: kernel/arch/ia32/Makefile.inc
===================================================================
--- kernel/arch/ia32/Makefile.inc	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/Makefile.inc	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,8 +34,5 @@
 ENDIANESS = LE
 
-CMN1 = -m32 -fno-omit-frame-pointer
-GCC_CFLAGS += $(CMN1)
-ICC_CFLAGS += $(CMN1)
-CLANG_CFLAGS += $(CMN1)
+COMMON_CFLAGS += -m32 -fno-omit-frame-pointer
 
 ## Accepted CPUs
@@ -43,31 +40,28 @@
 
 ifeq ($(PROCESSOR),i486)
-	CMN2 = -march=i486
+	COMMON_CFLAGS += -march=i486
 endif
 
 ifeq ($(PROCESSOR),athlon_xp)
-	CMN2 = -march=athlon-xp
+	COMMON_CFLAGS += -march=athlon-xp
 endif
 
 ifeq ($(PROCESSOR),athlon_mp)
-	CMN2 = -march=athlon-mp
+	COMMON_CFLAGS += -march=athlon-mp
 endif
 
 ifeq ($(PROCESSOR),pentium3)
-	CMN2 = -march=pentium3
+	COMMON_CFLAGS += -march=pentium3
 endif
 
 ifeq ($(PROCESSOR),pentium4)
-	CMN2 = -march=pentium4
+	COMMON_CFLAGS += -march=pentium4
 endif
 
 ifeq ($(PROCESSOR),core)
-	CMN2 = -march=prescott
+	COMMON_CFLAGS += -march=prescott
 endif
 
 FPU_NO_CFLAGS = -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow
-GCC_CFLAGS += $(CMN2)
-ICC_CFLAGS += $(CMN2)
-CLANG_CFLAGS += $(CMN2)
 
 ARCH_SOURCES = \
Index: kernel/arch/ia32/include/arch/arch.h
===================================================================
--- kernel/arch/ia32/include/arch/arch.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/arch.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define KERN_ia32_ARCH_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 extern void ia32_pre_main(uint32_t, void *);
Index: kernel/arch/ia32/include/arch/boot/memmap.h
===================================================================
--- kernel/arch/ia32/include/arch/boot/memmap.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/boot/memmap.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -63,5 +63,5 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
+#include <stdint.h>
 
 extern e820memmap_t e820table[MEMMAP_E820_MAX_RECORDS];
Index: kernel/arch/ia32/include/arch/cpuid.h
===================================================================
--- kernel/arch/ia32/include/arch/cpuid.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/cpuid.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,6 +43,6 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
 #include <arch/cpu.h>
+#include <stdint.h>
 
 typedef struct {
Index: kernel/arch/ia32/include/arch/fpu_context.h
===================================================================
--- kernel/arch/ia32/include/arch/fpu_context.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/fpu_context.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define KERN_ia32_FPU_CONTEXT_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 #define FPU_CONTEXT_ALIGN  16
Index: kernel/arch/ia32/include/arch/interrupt.h
===================================================================
--- kernel/arch/ia32/include/arch/interrupt.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/interrupt.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,7 +36,7 @@
 #define KERN_ia32_INTERRUPT_H_
 
-#include <typedefs.h>
 #include <arch/istate.h>
 #include <arch/pm.h>
+#include <stdint.h>
 
 #define IVT_ITEMS  IDT_ITEMS
Index: kernel/arch/ia32/include/arch/mm/asid.h
===================================================================
--- kernel/arch/ia32/include/arch/mm/asid.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/mm/asid.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,5 +43,5 @@
 #define KERN_ia32_ASID_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 
 typedef int32_t asid_t;
Index: kernel/arch/ia32/include/arch/mm/frame.h
===================================================================
--- kernel/arch/ia32/include/arch/mm/frame.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/mm/frame.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,6 +43,4 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
-
 extern void frame_low_arch_init(void);
 extern void frame_high_arch_init(void);
Index: kernel/arch/ia32/include/arch/mm/km.h
===================================================================
--- kernel/arch/ia32/include/arch/mm/km.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/mm/km.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #define KERN_ia32_KM_H_
 
+#include <stdbool.h>
 #include <typedefs.h>
 
Index: kernel/arch/ia32/include/arch/mm/page.h
===================================================================
--- kernel/arch/ia32/include/arch/mm/page.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/mm/page.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,5 @@
 
 #include <arch/mm/frame.h>
+#include <stdbool.h>
 #include <trace.h>
 
@@ -145,5 +146,5 @@
 #include <mm/mm.h>
 #include <arch/interrupt.h>
-#include <typedefs.h>
+#include <stddef.h>
 
 /* Page fault error codes. */
Index: kernel/arch/ia32/include/arch/proc/task.h
===================================================================
--- kernel/arch/ia32/include/arch/proc/task.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/proc/task.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define KERN_ia32_TASK_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 #include <adt/bitmap.h>
 
Index: kernel/arch/ia32/include/arch/proc/thread.h
===================================================================
--- kernel/arch/ia32/include/arch/proc/thread.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/proc/thread.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,6 +36,4 @@
 #define KERN_ia32_THREAD_H_
 
-#include <typedefs.h>
-
 typedef struct {
 } thread_arch_t;
Index: kernel/arch/ia32/include/arch/smp/apic.h
===================================================================
--- kernel/arch/ia32/include/arch/smp/apic.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/smp/apic.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,6 +41,6 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
 #include <cpu.h>
+#include <stdint.h>
 
 #define FIXED  (0 << 0)
Index: kernel/arch/ia32/include/arch/smp/mps.h
===================================================================
--- kernel/arch/ia32/include/arch/smp/mps.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/smp/mps.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define KERN_ia32_MPS_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 #include <synch/waitq.h>
 #include <config.h>
Index: kernel/arch/ia32/include/arch/smp/smp.h
===================================================================
--- kernel/arch/ia32/include/arch/smp/smp.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/smp/smp.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,6 @@
 #define KERN_ia32_SMP_H_
 
-#include <typedefs.h>
+#include <stdbool.h>
+#include <stddef.h>
 
 /** SMP config opertaions interface. */
Index: kernel/arch/ia32/include/arch/types.h
===================================================================
--- kernel/arch/ia32/include/arch/types.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/types.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,6 @@
 #define KERN_ia32_TYPES_H_
 
+#include <arch/common.h>
+
 typedef uint32_t size_t;
 typedef int32_t ssize_t;
@@ -51,7 +53,4 @@
 } fncptr_t;
 
-#define INTN_C(c)   INT32_C(c)
-#define UINTN_C(c)  UINT32_C(c)
-
 #define PRIdn  PRId32  /**< Format for native_t. */
 #define PRIun  PRIu32  /**< Format for sysarg_t. */
Index: kernel/arch/ia32/include/arch/vreg.h
===================================================================
--- kernel/arch/ia32/include/arch/vreg.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/include/arch/vreg.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,5 +40,5 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
+#include <stdint.h>
 
 extern uint32_t *vreg_ptr;
Index: kernel/arch/ia32/src/boot/multiboot.S
===================================================================
--- kernel/arch/ia32/src/boot/multiboot.S	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/src/boot/multiboot.S	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -165,5 +165,4 @@
  */
 FUNCTION_BEGIN(map_kernel_pse)
-map_kernel_pse:
 	/* Paging features */
 	movl %cr4, %ecx
Index: kernel/arch/ia32/src/boot/multiboot2.S
===================================================================
--- kernel/arch/ia32/src/boot/multiboot2.S	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/src/boot/multiboot2.S	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -52,4 +52,5 @@
 		.word MULTIBOOT2_FLAGS_REQUIRED
 		.long tag_info_req_end - tag_info_req_start
+		.long MULTIBOOT2_TAG_CMDLINE
 		.long MULTIBOOT2_TAG_MODULE
 		.long MULTIBOOT2_TAG_MEMMAP
Index: kernel/arch/ia32/src/cpu/cpu.c
===================================================================
--- kernel/arch/ia32/src/cpu/cpu.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/src/cpu/cpu.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,5 @@
 
 #include <arch.h>
-#include <typedefs.h>
+#include <stdint.h>
 #include <print.h>
 #include <fpu_context.h>
Index: kernel/arch/ia32/src/ddi/ddi.c
===================================================================
--- kernel/arch/ia32/src/ddi/ddi.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/src/ddi/ddi.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,6 +35,7 @@
 #include <ddi/ddi.h>
 #include <arch/ddi/ddi.h>
+#include <assert.h>
 #include <proc/task.h>
-#include <typedefs.h>
+#include <stddef.h>
 #include <adt/bitmap.h>
 #include <mm/slab.h>
@@ -63,5 +64,5 @@
 	
 	if (elements > 0) {
-		ASSERT(TASK->arch.iomap.bits);
+		assert(TASK->arch.iomap.bits);
 		
 		bitmap_t iomap;
Index: kernel/arch/ia32/src/debug/stacktrace.c
===================================================================
--- kernel/arch/ia32/src/debug/stacktrace.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/arch/ia32/src/debug/stacktrace.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,6 +34,7 @@
 
 #include <stacktrace.h>
+#include <stdbool.h>
+#include <stdint.h>
 #include <syscall/copy.h>
-#include <typedefs.h>
 
 #define FRAME_OFFSET_FP_PREV  0
